#dontinclude
; include file

; 4 color graphics 128x96

; coco3 can edit palette

function	a_information
rem	cg3 is a display of 128x96x4	
rem	using sprites requires your background layer to be draw on both screens 0,1 
rem	and have your sync to screen 1.    can not be double buffered
rem	sprites are loaded onto page 2

a_information

	rts

endfunction


function	cg3_setdisplay	cg3_setdisplay_c
rem	cg3_setdisplay( mode.b )
rem	
rem	sets the display mode to 128x96x4 color mode with color set 0 or 1
rem	
def	cg3_setdisplay_c	byte

stack	x

cg3_setdisplay

	lda	#0
	ldx	#65472
	sta	0,x
	ldx	#65474
	sta	0,x
	ldx	#65476
	sta	1,x



; setup memory page 0
; @e00
	clra	;set value 7 so its at 3584 view
	ldx	#$ffc6
	sta	1,x
	sta	3,x
	sta	5,x
	sta	6,x
	sta	8,x
	sta	10,x
	sta	12,x


	if	b,cg3_setdisplay_c=#0
;192 / 200
	lda	$ff22
	ora	#192
	sta	$ff22
	endif

	if	b,cg3_setdisplay_c=#1
	lda	$ff22
	ora	#200
	sta	$ff22
	endif

	if	b,cg3_setdisplay_c=#2
	lda	#248
	sta	$ff22
	endif


	rts

endfunction




;**********************************************************************************************************************

function	cg3_sync	cg3_sync_pg
rem	cg3_sync( page.b )
rem	syncs the working display onto screen
rem	
rem
	
def	cg3_sync_pg	byte

stack	x

cg3_sync
	lda	$ff03
	bpl	cg3_sync

	if	b,cg3_sync_pg=#0
; setup memory page 0
; @e00=7
	clra	;set value 7 so its at 3584 view
	ldx	#$ffc6
	sta	1,x
	sta	3,x
	sta	5,x
	sta	6,x
	sta	8,x
	sta	10,x
	sta	12,x
	endif

	if	b,cg3_sync_pg=#1
; setup memory page 1
; @1a00 =13
	clra	;
	ldx	#$ffc6
	sta	1,x
	sta	2,x
	sta	5,x
	sta	7,x
	sta	8,x
	sta	10,x
	sta	12,x
	endif


	if	b,cg3_sync_pg=#2
; setup memory page 2
; @2600 = 19
	clra	;set value 7 so its at 9728 view
	ldx	#$ffc6
	sta	1,x
	sta	3,x
	sta	4,x
	sta	6,x
	sta	9,x
	sta	10,x
	sta	12,x
	endif

	rts
endfunction





;**********************************************************************************************************************

function	cg3_nosync	cg3_nosync_pg
rem	cg3_nosync( page.b )
rem	syncs the working display onto screen
rem	
rem	
def	cg3_nosync_pg	byte

stack	x

cg3_nosync
;	lda	$ff03
;	bpl	cg3_nosync

	if	b,cg3_nosync_pg=#0
; setup memory page 0
; @e00=7
	clra	;set value 7 so its at 3584 view
	ldx	#$ffc6
	sta	1,x
	sta	3,x
	sta	5,x
	sta	6,x
	sta	8,x
	sta	10,x
	sta	12,x
	endif

	if	b,cg3_nosync_pg=#1
; setup memory page 1
; @1a00 =13
	clra	;
	ldx	#$ffc6
	sta	1,x
	sta	2,x
	sta	5,x
	sta	7,x
	sta	8,x
	sta	10,x
	sta	12,x
	endif


	if	b,cg3_nosync_pg=#2
; setup memory page 2
; @2600 = 19
	clra	;set value 7 so its at 9728 view
	ldx	#$ffc6
	sta	1,x
	sta	3,x
	sta	4,x
	sta	6,x
	sta	9,x
	sta	10,x
	sta	12,x
	endif



	rts
endfunction




; *************************************************************************************
function	cg3_mesh3d	cg3_mesh3d_scrn,cg3_mesh3d_x1,cg3_mesh3d_y1,cg3_mesh3d_x2,cg3_mesh3d_y2,cg3_mesh3d_col1
rem	cg3_mesh3d( page.b , x1.b , y1.b , x2.b , y2.b , color.b)
rem	resolution x=0-127 y=0-95 color=0-3
rem	expiremental
rem	

def	cg3_mesh3d_scrn	byte
def	cg3_mesh3d_x1	byte
def	cg3_mesh3d_y1	byte
def	cg3_mesh3d_x2	byte
def	cg3_mesh3d_y2	byte
def	cg3_mesh3d_col1	byte
def	cg3_mesh3d_xdist	byte
def	cg3_mesh3d_ydist	byte
def	cg3_mesh3d_wn	byte	;whole fraction
def	cg3_mesh3d_xc	byte	;direction control
def	cg3_mesh3d_yc	byte
def	cg3_mesh3d_ycnt	byte
def	cg3_mesh3d_xcnt	byte
def	cg3_mesh3d_cnt	byte
cg3_mesh3d_scrntbl	fdb	3584,6656
cg3_mesh3d_dotmsk	fcb	63,207,243,252
cg3_mesh3d_dotmsk2	fcb	192,48,12,3
cg3_mesh3d_dotcol	fcb	0,85,170,255

def	cg3_mesh3d_dotst	byte	; dot store
def	cg3_mesh3d_dotm	byte	;dot masked color



cg3_mesh3d_test	fcb	1,2,3,2,1,0,1,2,3,2,1,0,1,2,3,2

def	cg3_mesh3d_col_xc	byte
def	cg3_mesh3d_col_xcnt	byte
def	cg3_mesh3d_col_wn	byte
def	cg3_mesh3d_col_wn2	byte	;small number
def	cg3_mesh3d_col_xdist	byte


stack	x,y,u

cg3_mesh3d
	lda	#16
	sta	cg3_mesh3d_col_xdist
	lda	cg3_mesh3d_x1
	cmpa	cg3_mesh3d_x2
	bls	cg3_mesh3d_lind0
	lda	cg3_mesh3d_x1
	suba	cg3_mesh3d_x2
	sta	cg3_mesh3d_xdist
	clr	cg3_mesh3d_xc	; direction x-
	bra	cg3_mesh3d_lind1
cg3_mesh3d_lind0	lda	cg3_mesh3d_x2
	suba	cg3_mesh3d_x1
	sta	cg3_mesh3d_xdist
	lda	#1
	sta	cg3_mesh3d_xc	; direction x+
cg3_mesh3d_lind1	lda	cg3_mesh3d_y1
	cmpa	cg3_mesh3d_y2
	bls	cg3_mesh3d_lind2
	lda	cg3_mesh3d_y1
	suba	cg3_mesh3d_y2
	sta	cg3_mesh3d_ydist
	clr	cg3_mesh3d_yc	; direction y-
	bra	cg3_mesh3d_lind3
cg3_mesh3d_lind2	lda	cg3_mesh3d_y2
	suba	cg3_mesh3d_y1
	sta	cg3_mesh3d_ydist
	lda	#1
	sta	cg3_mesh3d_yc	; direction y+
; lets grab whole fraction
cg3_mesh3d_lind3	lda	cg3_mesh3d_xdist
	cmpa	cg3_mesh3d_ydist
	bls	cg3_mesh3d_yiswn
	lda	cg3_mesh3d_xdist
	sta	cg3_mesh3d_wn	; x is the whole number
	bra	cg3_mesh3d_drawln
cg3_mesh3d_yiswn
	lda	cg3_mesh3d_ydist
	sta	cg3_mesh3d_wn
; ok the distances are sorted
cg3_mesh3d_drawln
	lda	cg3_mesh3d_wn
	lsra
	sta	cg3_mesh3d_xcnt
	sta	cg3_mesh3d_ycnt
	lda	cg3_mesh3d_wn
	sta	cg3_mesh3d_cnt	;set counter
	inc	cg3_mesh3d_cnt

cg3_mesh3d_drawln1

; figure out texture scale


	ldb	cg3_mesh3d_wn
	stb	cg3_mesh3d_col_wn	;bigger fraction

	clr	cg3_mesh3d_col_xc	;clear counter
	clr	cg3_mesh3d_col_xcnt	;clear counter

cg3_mesh3d_drawln2




; dot draw
	lda	cg3_mesh3d_x1
	cmpa	#127
	bhi	cg3_mesh3d_nope2
	lda	cg3_mesh3d_y1
	cmpa	#95
	bhi	cg3_mesh3d_nope2
	ldb	cg3_mesh3d_scrn
	ldx	#cg3_mesh3d_scrntbl
	ldy	#cg3_mesh3d_dotmsk2
	ldu	#cg3_mesh3d_dotcol
	lslb	; scrn #*2
	abx
	ldx	,x
; x index is at start of screen
	lda	cg3_mesh3d_y1
	ldb	#32
	mul
	leax	d,x	; advance y pos
	lda	cg3_mesh3d_x1
	anda	#3	;mask out which dot of 4
	sta	cg3_mesh3d_dotst
	ldb	cg3_mesh3d_x1
	lsrb
	lsrb
	abx	;ok we are ready to draw (again, result is always 8 bits lcb)
; mask color

; load color from new table


	ldu	#cg3_mesh3d_test
	ldb	cg3_mesh3d_col_xc
	lda	b,u
	tfr	a,b
;	ldb	cg3_mesh3d_col1

	ldu	#cg3_mesh3d_dotcol
	lda	b,u
	ldb	cg3_mesh3d_dotst
	anda	b,y
	sta	cg3_mesh3d_dotm	;dot saved
; grab original
	ldu	#cg3_mesh3d_dotmsk	; 1 byte smaller/1 cycle faster
	lda	,x
	anda	b,u
	adda	cg3_mesh3d_dotm
	sta	,x

cg3_mesh3d_nope2

; end draw dot

;check advance texture

	lda	cg3_mesh3d_col_xcnt
	adda	cg3_mesh3d_col_xdist
	sta	cg3_mesh3d_col_xcnt



	if	b,cg3_mesh3d_col_xcnt>cg3_mesh3d_col_wn

cg3_mesh3d_scalex
	lda	cg3_mesh3d_col_xcnt
	suba	cg3_mesh3d_col_wn
	sta	cg3_mesh3d_col_xcnt
	lda	cg3_mesh3d_col_xc
	adda	#1
	sta	cg3_mesh3d_col_xc

	lda	cg3_mesh3d_col_xcnt
	cmpa	cg3_mesh3d_col_wn
	bhs	cg3_mesh3d_scalex
	

	endif





	lda	cg3_mesh3d_xcnt
	adda	cg3_mesh3d_xdist
	cmpa	cg3_mesh3d_wn
	bhs	cg3_mesh3d_adv2
	sta	cg3_mesh3d_xcnt
	bra	cg3_mesh3d_chk2
;
cg3_mesh3d_adv2
	suba	cg3_mesh3d_wn
	sta	cg3_mesh3d_xcnt
	lda	cg3_mesh3d_xc	;the direction? 0 left 1 right
	beq	cg3_mesh3d_xleft
; right
	inc	cg3_mesh3d_x1
	bra	cg3_mesh3d_chk2
cg3_mesh3d_xleft	dec	cg3_mesh3d_x1
cg3_mesh3d_chk2	lda	cg3_mesh3d_ycnt
	adda	cg3_mesh3d_ydist
	cmpa	cg3_mesh3d_wn
	bhs	cg3_mesh3d_advy2
	sta	cg3_mesh3d_ycnt
	bra	cg3_mesh3d_chk3
cg3_mesh3d_advy2	suba	cg3_mesh3d_wn
	sta	cg3_mesh3d_ycnt
	lda	cg3_mesh3d_yc	;the direction? 0 left 1 right
	beq	cg3_mesh3d_yleft
; right
	inc	cg3_mesh3d_y1
	bra	cg3_mesh3d_chk3
cg3_mesh3d_yleft	dec	cg3_mesh3d_y1
cg3_mesh3d_chk3	dec	cg3_mesh3d_cnt
	lbne	cg3_mesh3d_drawln2
cg3_mesh3d_nope
	rts

endfunction






 
; **********************************************************************************************************************
function	cg3_circle	cg3_circle_page,cg3_circle_sintb1,cg3_circle_plotx,cg3_circle_ploty,cg3_circle_radx,cg3_circle_rady,cg3_circle_angles,cg3_circle_anglee,cg3_circle_color
rem	cg3_circle( page.b , sinetable.w ,x1.b , y1.b , diamx.b , diamy.b , anglestart.b , angleend.b , color.b)
rem	max rad 34 circle angle 0-255 as percentage of 360
rem	does not push to stack uses x for sine table
rem	

def	cg3_circle_page	byte
def	cg3_circle_sintb1	word
def	cg3_circle_angles	byte
def	cg3_circle_anglee	byte
def	cg3_circle_plotx	byte
def	cg3_circle_ploty	byte
def	cg3_circle_radx	byte
def	cg3_circle_rady	byte
def	cg3_circle_color	byte

; pass over to dot

cg3_circle_scrntbl	fdb	3584,6656
cg3_circle_dotmsk	fcb	63,207,243,252
cg3_circle_dotmsk2	fcb	192,48,12,3
cg3_circle_dotcol	fcb	0,85,170,255

def	cg3_circle_dotst	byte	; dot store
def	cg3_circle_dotm	byte	;dot masked color

def	cg3_circle_x1	byte
def	cg3_circle_y1	byte

stack	x,y,u

cg3_circle

	clra
	ldx	cg3_circle_sintb1
	ldb	cg3_circle_angles
	abx
	ldb	,x
	lda	cg3_circle_radx
	mul
	aslb
	rola
	suba	cg3_circle_radx
	adda	cg3_circle_plotx
	sta	cg3_circle_x1
;cos
	ldx	cg3_circle_sintb1
	ldb	cg3_circle_angles
	addb	#64
	abx
	ldb	,x
	lda	cg3_circle_rady
	mul
	aslb
	rola
	suba	cg3_circle_rady
	adda	cg3_circle_ploty
	sta	cg3_circle_y1
;****************************************************************************
; dot draw
	lda	cg3_circle_x1
	cmpa	#127
	bhi	cg3_circle_nope2
	lda	cg3_circle_y1
	cmpa	#95
	bhi	cg3_circle_nope2
	ldb	cg3_circle_page
	ldx	#cg3_circle_scrntbl
	ldy	#cg3_circle_dotmsk2
	ldu	#cg3_circle_dotcol
	lslb	; scrn #*2
	abx
	ldx	,x
; x index is at start of screen
	lda	cg3_circle_y1
	ldb	#32
	mul
	leax	d,x	; advance y pos
	lda	cg3_circle_x1
	anda	#3	;mask out which dot of 4
	sta	cg3_circle_dotst
	ldb	cg3_circle_x1
	lsrb
	lsrb
	abx	;ok we are ready to draw (again, result is always 8 bits lcb)
; mask color
	ldb	cg3_circle_color
	lda	b,u
	ldb	cg3_circle_dotst
	anda	b,y
	sta	cg3_circle_dotm	;dot saved
; grab original
	ldu	#cg3_circle_dotmsk	; 1 byte smaller/1 cycle faster
	lda	,x
	anda	b,u
	adda	cg3_circle_dotm
	sta	,x

cg3_circle_nope2
; end draw dot

	lda	cg3_circle_angles
	inca
	sta	cg3_circle_angles
	cmpa	cg3_circle_anglee
	lbne	cg3_circle

	rts
endfunction






; *************************************************************************************
function	cg3_line	cg3_line_scrn,cg3_line_x1,cg3_line_y1,cg3_line_x2,cg3_line_y2,cg3_line_col1
rem	cg3_line( page.b , x1.b , y1.b , x2.b , y2.b , color.b)
rem	resolution x=0-127 y=0-95 color=0-3
def	cg3_line_scrn	byte
def	cg3_line_x1	byte
def	cg3_line_y1	byte
def	cg3_line_x2	byte
def	cg3_line_y2	byte
def	cg3_line_col1	byte
def	cg3_line_xdist	byte
def	cg3_line_ydist	byte
def	cg3_line_wn	byte	;whole fraction
def	cg3_line_xc	byte	;direction control
def	cg3_line_yc	byte
def	cg3_line_ycnt	byte
def	cg3_line_xcnt	byte
def	cg3_line_cnt	byte
cg3_line_scrntbl	fdb	3584,6656
cg3_line_dotmsk	fcb	63,207,243,252
cg3_line_dotmsk2	fcb	192,48,12,3
cg3_line_dotcol	fcb	0,85,170,255

def	cg3_line_dotst	byte	; dot store
def	cg3_line_dotm	byte	;dot masked color

stack	x,y,u

cg3_line
	lda	cg3_line_x1
	cmpa	cg3_line_x2
	bls	cg3_line_lind0
	lda	cg3_line_x1
	suba	cg3_line_x2
	sta	cg3_line_xdist
	clr	cg3_line_xc	; direction x-
	bra	cg3_line_lind1
cg3_line_lind0	lda	cg3_line_x2
	suba	cg3_line_x1
	sta	cg3_line_xdist
	lda	#1
	sta	cg3_line_xc	; direction x+
cg3_line_lind1	lda	cg3_line_y1
	cmpa	cg3_line_y2
	bls	cg3_line_lind2
	lda	cg3_line_y1
	suba	cg3_line_y2
	sta	cg3_line_ydist
	clr	cg3_line_yc	; direction y-
	bra	cg3_line_lind3
cg3_line_lind2	lda	cg3_line_y2
	suba	cg3_line_y1
	sta	cg3_line_ydist
	lda	#1
	sta	cg3_line_yc	; direction y+
; lets grab whole fraction
cg3_line_lind3	lda	cg3_line_xdist
	cmpa	cg3_line_ydist
	bls	cg3_line_yiswn
	lda	cg3_line_xdist
	sta	cg3_line_wn	; x is the whole number
	bra	cg3_line_drawln
cg3_line_yiswn	lda	cg3_line_ydist
	sta	cg3_line_wn
; ok the distances are sorted
cg3_line_drawln
	lda	cg3_line_wn
	lsra
	sta	cg3_line_xcnt
	sta	cg3_line_ycnt
	lda	cg3_line_wn
	sta	cg3_line_cnt	;set counter
	inc	cg3_line_cnt
cg3_line_drawln1


; dot draw
	lda	cg3_line_x1
	cmpa	#127
	bhi	cg3_line_nope2
	lda	cg3_line_y1
	cmpa	#95
	bhi	cg3_line_nope2
	ldb	cg3_line_scrn
	ldx	#cg3_line_scrntbl
	ldy	#cg3_line_dotmsk2
	ldu	#cg3_line_dotcol
	lslb	; scrn #*2
	abx
	ldx	,x
; x index is at start of screen
	lda	cg3_line_y1
	ldb	#32
	mul
	leax	d,x	; advance y pos
	lda	cg3_line_x1
	anda	#3	;mask out which dot of 4
	sta	cg3_line_dotst
	ldb	cg3_line_x1
	lsrb
	lsrb
	abx	;ok we are ready to draw (again, result is always 8 bits lcb)
; mask color
	ldb	cg3_line_col1
	lda	b,u
	ldb	cg3_line_dotst
	anda	b,y
	sta	cg3_line_dotm	;dot saved
; grab original
	ldu	#cg3_line_dotmsk	; 1 byte smaller/1 cycle faster
	lda	,x
	anda	b,u
	adda	cg3_line_dotm
	sta	,x

cg3_line_nope2
; end draw dot

	lda	cg3_line_xcnt
	adda	cg3_line_xdist
	cmpa	cg3_line_wn
	bhs	cg3_line_adv2
	sta	cg3_line_xcnt
	bra	cg3_line_chk2
;
cg3_line_adv2
	suba	cg3_line_wn
	sta	cg3_line_xcnt
	lda	cg3_line_xc	;the direction? 0 left 1 right
	beq	cg3_line_xleft
; right
	inc	cg3_line_x1
	bra	cg3_line_chk2
cg3_line_xleft	dec	cg3_line_x1
cg3_line_chk2	lda	cg3_line_ycnt
	adda	cg3_line_ydist
	cmpa	cg3_line_wn
	bhs	cg3_line_advy2
	sta	cg3_line_ycnt
	bra	cg3_line_chk3
cg3_line_advy2	suba	cg3_line_wn
	sta	cg3_line_ycnt
	lda	cg3_line_yc	;the direction? 0 left 1 right
	beq	cg3_line_yleft
; right
	inc	cg3_line_y1
	bra	cg3_line_chk3
cg3_line_yleft	dec	cg3_line_y1
cg3_line_chk3	dec	cg3_line_cnt
	lbne	cg3_line_drawln1
cg3_line_nope
	rts

endfunction





; ************************************************************************************************************************
function	cg3_ppoint	cg3_ppoint_scrn,cg3_ppoint_xp1,cg3_ppoint_yp1
rem	cg3_ppoint( page.b , xpos.b , ypos.b ) 0-127 x 0-95 
rem	returns color back to b register
rem	
rem	

def	cg3_ppoint_scrn	byte
def	cg3_ppoint_xp1	byte
def	cg3_ppoint_yp1	byte
def	cg3_ppoint_dotst	byte

cg3_ppoint_scrntbl	fdb	3584,6656

stack	x

cg3_ppoint
	lda	cg3_ppoint_scrn
	ldx	#cg3_ppoint_scrntbl
	ldb	#2
	mul
	leax	b,x
	ldx	,x
; x index is at start of screen
	lda	cg3_ppoint_yp1
	ldb	#32
	mul
	leax	d,x	; advance y pos
	lda	cg3_ppoint_xp1
	anda	#3	;mask out which dot of 4
	sta	cg3_ppoint_dotst
	ldb	cg3_ppoint_xp1
	lsrb
	lsrb
	leax	b,x	;ok we are ready to draw
	lda	cg3_ppoint_dotst
	cmpa	#3
	beq	cg3_ppoint_howb0
	cmpa	#2
	beq	cg3_ppoint_howb1
	cmpa	#1
	beq	cg3_ppoint_howb2
; its 4th dot
	ldb	,x
	lsrb
	lsrb
	lsrb
	lsrb
	lsrb
	lsrb
	andb	#3
	rts
cg3_ppoint_howb0	ldb	,x
	andb	#3
	rts
cg3_ppoint_howb1	ldb	,x
	lsrb
	lsrb
	andb	#3
	rts
cg3_ppoint_howb2	ldb	,x
	lsrb
	lsrb
	lsrb
	lsrb
	andb	#3
	rts
endfunction




;*****************************************************************************************************************************************


function	cg3_pset	cg3_pset_page,cg3_pset_x,cg3_pset_y,cg3_pset_col
rem	cg3_pset( page.b , x.b , y.b , color.b )
rem	sets a dot with specified color on the screen
rem	page 0-1 x 0-127 y 0-95 color 0-3
rem	uses stack x,y,u,d

def	cg3_pset_page	byte
def	cg3_pset_x	byte
def	cg3_pset_y	byte
def	cg3_pset_col	byte
def	cg3_pset_dotst	byte
def	cg3_pset_dotm	byte

cg3_pset_scrtbl	fdb	3584,6656
cg3_pset_dotmsk	fcb	63,207,243,252
cg3_pset_dotmsk2	fcb	192,48,12,3
cg3_pset_dotcol	fcb	0,85,170,255

stack	x,y,u

cg3_pset
	if	b,cg3_pset_x>#127
	rts
	endif
	if	b,cg3_pset_y>#95
	rts
	endif
	if	b,cg3_pset_page>#1
	lda	#1
	sta	cg3_pset_page
	endif

	ldb	cg3_pset_page
	ldx	#cg3_pset_scrtbl
	ldy	#cg3_pset_dotmsk2
	ldu	#cg3_pset_dotcol
	lslb	; scrn #*2
	abx
	ldx	,x
; x index is at start of screen
	lda	cg3_pset_y
	ldb	#32
	mul
	leax	d,x	; advance y pos
	lda	cg3_pset_x
	anda	#3	;mask out which dot of 4
	sta	cg3_pset_dotst
	ldb	cg3_pset_x
	lsrb
	lsrb
	abx	;ok we are ready to draw (again, result is always 8 bits lcb)
; mask color
	ldb	cg3_pset_col
	lda	b,u
	ldb	cg3_pset_dotst
	anda	b,y
	sta	cg3_pset_dotm	;dot saved
; grab original
	ldu	#cg3_pset_dotmsk	; 1 byte smaller/1 cycle faster
	lda	,x
	anda	b,u
	adda	cg3_pset_dotm
	sta	,x

	rts

endfunction



;**********************************************************************************************************************************

function	cg3_cls	cg3_cls_page,cg3_cls_color
rem	cg3_cls( page.b , color.b  )
rem	
rem	clears color 0-3 on pages 0-1
rem	
def	cg3_cls_page	byte
def	cg3_cls_color	byte

stack	x,y,u

cg3_cls
	lda	cg3_cls_color
	anda	#3
	sta	cg3_cls_color

	if	b,cg3_cls_page=#0

	ldu	#$1a00	;end of page 1
	lda	cg3_cls_color
	lsla
	lsla
	adda	cg3_cls_color
	lsla
	lsla
	adda	cg3_cls_color
	lsla
	lsla
	adda	cg3_cls_color
	tfr	a,b
	tfr	d,x
	tfr	d,y

cg3_cls_pg0
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	cmpu	#$e00
	bhi	cg3_cls_pg0
	rts

	else

	ldu	#$2600	;end of page 1


	lda	cg3_cls_color
	lsla
	lsla
	adda	cg3_cls_color
	lsla
	lsla
	adda	cg3_cls_color
	lsla
	lsla
	adda	cg3_cls_color
	tfr	a,b
	tfr	d,x
	tfr	d,y

cg3_cls_pg1
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	pshu	x,y,d,a,b
	cmpu	#$1a00
	bhi	cg3_cls_pg1
	rts
	endif
	rts

endfunction



;************************************************************************************************************************

function	cg3_loadtiles	cg3_loadtiles_str,cg3_loadtiles_cnt,cg3_loadtiles_adr
rem	cg3_loadtiles( tilestart.b ,  tilecount.b , loadaddress.w )
rem	
rem	loads x amount of tiles into tile memory 192 max
rem	
def	cg3_loadtiles_str	byte
def	cg3_loadtiles_cnt	byte
def	cg3_loadtiles_adr	word

stack	x,y,u

cg3_loadtiles
	ldx	#$2620
	lda	cg3_loadtiles_str
	ldb	#16
	mul
	leax	d,x
	tfr	x,y
	ldx	cg3_loadtiles_adr

cg3_loadtiles_lp0
	ldd	,x++
	std	,y++
	ldd	,x++
	std	,y++
	ldd	,x++
	std	,y++
	ldd	,x++
	std	,y++
	ldd	,x++
	std	,y++
	ldd	,x++
	std	,y++
	ldd	,x++
	std	,y++
	ldd	,x++
	std	,y++

	ldb	cg3_loadtiles_cnt
	subb	#1
	stb	cg3_loadtiles_cnt
	cmpb	#0
	bhi	cg3_loadtiles_lp0

	rts


endfunction

; **********************************************************************************************************************************

function	cg3_loadfont	cg3_loadfont_bg
rem	cg3_loadfont( bgcolor.b )
rem	
rem	loads a basic 65 tile font into the tile memory starting at ascii 32
rem	first 2 tiles are padding for sprite overlap 
def	cg3_loadfont_bg	byte

def	cg3_loadfont_store1	word
def	cg3_loadfont_dot	byte
def	cg3_loadfont_cnt	byte
def	cg3_loadfont_ctr	byte

stack	x,y,u

cg3_loadfont

	ldu	#cg3_loadfont_store1

	ldx	#cg3_loadfont_data
	ldy	#$2620
	ldb	#67
	stb	cg3_loadfont_cnt



cg3_loadfont_lp


	lda	#8
	sta	cg3_loadfont_ctr

cg3_loadfont_lp66

	ldd	,x++
	std	,u

	ldb	#8
cg3_loadfont_lppb

;1 pixel
	lda	#0
	andcc	#$fe
	lsl	1,u
	rol	,u	
	rola
	lsl	1,u
	rol	,u
	rola
	sta	cg3_loadfont_dot
	cmpa	#0
	bne	cg3_loadfont_skipdot

	lda	cg3_loadfont_bg
	adda	1,u
	sta	1,u
	bra	cg3_loadfont_skipdot2

cg3_loadfont_skipdot
	lda	cg3_loadfont_dot
	adda	1,u
	sta	1,u

cg3_loadfont_skipdot2
	decb
	bne	cg3_loadfont_lppb

	ldd	,u
	std	,y++

	dec	cg3_loadfont_ctr
	lda	cg3_loadfont_ctr
	bne	cg3_loadfont_lp66




	ldb	cg3_loadfont_cnt
	subb	#1
	stb	cg3_loadfont_cnt
	cmpb	#0
	bhi	cg3_loadfont_lp


	rts


cg3_loadfont_data
; sprite #1
	fdb	0,0,0,0,0,0,0,0
; sprite #2
	fdb	320,320,320,320,0,0,320,0
; sprite #3
	fdb	0,1040,1040,0,0,0,0,0
; sprite #4
	fdb	1040,1040,5460,1040,5460,1040,1040,0
; sprite #5
	fdb	272,1364,4096,1360,4,5456,1088,0
; sprite #6
	fdb	0,5124,5136,64,256,1044,4116,0
; sprite #7
	fdb	320,1040,1040,320,1348,4180,1360,0
; sprite #8
	fdb	0,320,320,1024,0,0,0,0
; sprite #9
	fdb	0,320,1280,1024,1024,1280,320,0
; sprite #10
	fdb	0,320,80,16,16,80,320,0
; sprite #11
	fdb	0,5200,1344,5456,5456,1344,5200,0
; sprite #12
	fdb	0,320,320,5460,5460,320,320,0
; sprite #13
	fdb	0,0,0,0,0,320,320,1024
; sprite #14
	fdb	0,0,0,5460,5460,0,0,0
; sprite #15
	fdb	0,0,0,0,0,320,320,0
; sprite #16
	fdb	0,20,80,320,1280,5120,4096,0
; sprite #17
	fdb	1360,5140,4164,4420,4356,5140,1360,0
; sprite #18
	fdb	320,1344,320,320,320,320,5460,0
; sprite #19
	fdb	1360,4100,4,80,1280,5120,5460,0
; sprite #20
	fdb	1360,4100,4,80,4,4100,1360,0
; sprite #21
	fdb	4112,4112,4112,5460,16,16,16,0
; sprite #22
	fdb	5460,4096,4096,5456,4,4,5456,0
; sprite #23
	fdb	1360,4100,4096,5456,4100,4100,1360,0
; sprite #24
	fdb	5460,20,20,80,80,320,320,0
; sprite #25
	fdb	1360,4100,4100,1360,4100,4100,1360,0
; sprite #26
	fdb	1360,4100,4100,1364,4,4100,1360,0
; sprite #27
	fdb	0,320,320,0,0,320,320,0
; sprite #28
	fdb	0,320,320,0,0,320,320,1024
; sprite #29
	fdb	0,20,320,5120,5120,320,20,0
; sprite #30
	fdb	0,0,5460,0,0,5460,0,0
; sprite #31
	fdb	0,5120,320,20,20,320,5120,0
; sprite #32
	fdb	1360,4116,20,336,0,320,320,0
; sprite #33
	fdb	1360,4100,4420,4436,4436,4096,1364,0
; sprite #34
	fdb	320,1360,1040,5140,5460,4100,4100,0
; sprite #35
	fdb	5456,4100,4100,5456,4100,4100,5456,0
; sprite #36
	fdb	1360,4100,4096,4096,4096,4100,1360,0
; sprite #37
	fdb	5440,4112,4100,4100,4100,4112,5440,0
; sprite #38
	fdb	5460,4096,4096,5440,4096,4096,5460,0
; sprite #39
	fdb	5460,4096,4096,5440,4096,4096,4096,0
; sprite #40
	fdb	5460,4096,4096,4180,4100,4100,5460,0
; sprite #41
	fdb	4100,4100,4100,5460,4100,4100,4100,0
; sprite #42
	fdb	5460,320,320,320,320,320,5460,0
; sprite #43
	fdb	84,16,16,16,16,1040,320,0
; sprite #44
	fdb	4100,4112,4160,5376,4160,4112,4100,0
; sprite #45
	fdb	1024,1024,1024,1024,1024,1024,1364,0
; sprite #46
	fdb	4100,5140,5460,4420,4100,4100,4100,0
; sprite #47
	fdb	4100,5124,5380,4420,4180,4116,4100,0
; sprite #48
	fdb	5460,4100,4100,4100,4100,4100,5460,0
; sprite #49
	fdb	5456,4100,4100,5456,4096,4096,4096,0
; sprite #50
	fdb	1360,4100,4100,4100,4164,4116,1364,0
; sprite #51
	fdb	5456,4100,4100,5456,4160,4112,4100,0
; sprite #52
	fdb	1364,4096,4096,1360,4,4,5456,0
; sprite #53
	fdb	5460,320,320,320,320,320,320,0
; sprite #54
	fdb	4100,4100,4100,4100,4100,4100,1360,0
; sprite #55
	fdb	4100,4100,4100,1040,1040,320,320,0
; sprite #56
	fdb	4100,4100,4100,4420,4420,1040,1040,0
; sprite #57
	fdb	4100,5140,1360,320,1360,5140,4100,0
; sprite #58
	fdb	4100,4100,5140,1360,320,320,320,0
; sprite #59
	fdb	5460,20,80,320,1280,5120,5460,0
; sprite #60
	fdb	1360,1280,1280,1280,1280,1280,1360,0
; sprite #61
	fdb	0,5120,1280,320,80,20,4,0
; sprite #62
	fdb	1360,80,80,80,80,80,1360,0
; sprite #63
	fdb	320,1040,4100,0,0,0,0,0
; sprite #64
	fdb	0,0,0,0,0,0,5460,0
; sprite #65
	fdb	0,320,320,16,0,0,0,0


endfunction




;******************************************************************************************************************************************
function	cg3_print	cg3_print_page,cg3_print_x,cg3_print_y,cg3_print_text,cg3_print_skip,cg3_print_max
rem	cg3_print( page.b , posx.b , posy.b , textpointer.w , skipchrs.b , length.b  )
rem	
rem	print text on the screen res tiles x=0-119  y=0-87
rem	bg color not setup yet

def	cg3_print_page	byte
def	cg3_print_x	byte
def	cg3_print_y	byte
def	cg3_print_text	word
def	cg3_print_skip	byte
def	cg3_print_max	byte
def	cg3_print_chr	byte

stack	x,y,u


cg3_print
	if	b,cg3_print_page=#0
	ldx	#$e00
	else
	ldx	#$1a00
	endif

; x has screen start
	lda	#32
	ldb	cg3_print_y
	mul
	leax	d,x
	ldb	cg3_print_x
	lsrb
	lsrb
	abx

; x is ready for printing
	ldu	cg3_print_text
	ldb	cg3_print_skip
	clra
	leau	d,u
; u is ready for reading text


cg3_print_mainlp
	lda	,u+
	sta	cg3_print_chr

	if	b,cg3_print_chr=#0	or	b,cg3_print_max=>#127	;BELOW ZERO
	rts
	endif

	lda	cg3_print_chr	;sub 32 for ascii font
	suba	#32
	sta	cg3_print_chr

	lda	cg3_print_max	;length subtract 1
	suba	#1
	sta	cg3_print_max

; load y with graphic
	ldy	#$2620	;start of tiles
	lda	#16
	ldb	cg3_print_chr
	mul
	leay	d,y
; ready with chr

	if	b,cg3_print_chr=#0
	leax	2,x

	lbra	cg3_print_mainlp
	endif
	

	ldd	,y++
	std	,x++
	leax	30,x	;next line
	ldd	,y++
	std	,x++
	leax	30,x	;next line
	ldd	,y++
	std	,x++
	leax	30,x	;next line
	ldd	,y++
	std	,x++
	leax	30,x	;next line
	ldd	,y++
	std	,x++
	leax	30,x	;next line
	ldd	,y++
	std	,x++
	leax	30,x	;next line
	ldd	,y++
	std	,x++
	leax	30,x	;next line
	ldd	,y
	std	,x
	leax	-100,x	;back to top
	leax	-122,x	;back to top - 8

	lbra	cg3_print_mainlp


endfunction





;***********************************************************************************************************************************************************
function	cg3_sprite2	cg3_sprite2_page,cg3_sprite2_tile,cg3_sprite2_x,cg3_sprite2_y,cg3_sprite2_sx,cg3_sprite2_sy
rem	cg3_sprite2( page.b , tile.b , posx.b , posy.b , sizex.b , sizey.b )
rem	alignment at byte level with transparency
rem	
rem	

def	cg3_sprite2_page	byte
def	cg3_sprite2_tile	byte
def	cg3_sprite2_x	byte
def	cg3_sprite2_y	byte
def	cg3_sprite2_sx	byte
def	cg3_sprite2_sy	byte


def	cg3_sprite2_d0	byte
def	cg3_sprite2_d1	byte
def	cg3_sprite2_d2	byte
def	cg3_sprite2_d3	byte

def	cg3_sprite2_cnt	byte
def	cg3_sprite2_sxc	byte
def	cg3_sprite2_syc	byte
def	cg3_sprite2_savex	word

def	cg3_sprite2_trans	byte



stack	x,y,u

cg3_sprite2

; prep x for screen start
	if	b,cg3_sprite2_page=#0
	ldx	#$e00
	else
	ldx	#$1a00
	endif

	lda	#32
	ldb	cg3_sprite2_y
	mul
	leax	d,x

	lda	cg3_sprite2_x
	lsra
	lsra
	leax	a,x
; x is ready to draw
	stx	cg3_sprite2_savex


	ldy	#$2620
	lda	#16
	ldb	cg3_sprite2_tile
	mul
	leay	d,y
; y is ready with tile


	ldb	#0
	stb	cg3_sprite2_sxc
	stb	cg3_sprite2_syc


cg3_sprite2_lp0

	ldb	#8
cg3_sprite2_lp1
	lda	,x
	anda	#192
	sta	cg3_sprite2_d0
	lda	,x
	anda	#48
	sta	cg3_sprite2_d1
	lda	,x
	anda	#12
	sta	cg3_sprite2_d2
	lda	,x
	anda	#3
	sta	cg3_sprite2_d3

	lda	,y
	anda	#192
	beq	cg3_sprite2_n0
	sta	cg3_sprite2_d0	;write
cg3_sprite2_n0

	lda	,y
	anda	#48
	beq	cg3_sprite2_n1
	sta	cg3_sprite2_d1	;write
cg3_sprite2_n1

	lda	,y
	anda	#12
	beq	cg3_sprite2_n2
	sta	cg3_sprite2_d2	;write
cg3_sprite2_n2

	lda	,y
	anda	#3
	beq	cg3_sprite2_n3
	sta	cg3_sprite2_d3	;write
cg3_sprite2_n3

	lda	cg3_sprite2_d3
	adda	cg3_sprite2_d2
	adda	cg3_sprite2_d1
	adda	cg3_sprite2_d0
	sta	,x




	lda	1,x
	anda	#192
	sta	cg3_sprite2_d0
	lda	1,x
	anda	#48
	sta	cg3_sprite2_d1
	lda	1,x
	anda	#12
	sta	cg3_sprite2_d2
	lda	1,x
	anda	#3
	sta	cg3_sprite2_d3

	lda	1,y
	anda	#192
	beq	cg3_sprite2_nn0
	sta	cg3_sprite2_d0	;write
cg3_sprite2_nn0

	lda	1,y
	anda	#48
	beq	cg3_sprite2_nn1
	sta	cg3_sprite2_d1	;write
cg3_sprite2_nn1

	lda	1,y
	anda	#12
	beq	cg3_sprite2_nn2
	sta	cg3_sprite2_d2	;write
cg3_sprite2_nn2

	lda	1,y
	anda	#3
	beq	cg3_sprite2_nn3
	sta	cg3_sprite2_d3	;write
cg3_sprite2_nn3

	lda	cg3_sprite2_d3
	adda	cg3_sprite2_d2
	adda	cg3_sprite2_d1
	adda	cg3_sprite2_d0
	sta	1,x


	leax	32,x
	leay	2,y
	decb
	lbne	cg3_sprite2_lp1


	inc	cg3_sprite2_syc
	lda	cg3_sprite2_syc
	cmpa	cg3_sprite2_sy
	lblo	cg3_sprite2_lp0

	clr	cg3_sprite2_syc
	inc	cg3_sprite2_sxc


; prep x for screen start
	ldx	cg3_sprite2_savex
	lda	cg3_sprite2_sxc
	ldb	#2
	mul
	leax	d,x

	lda	cg3_sprite2_sxc
	cmpa	cg3_sprite2_sx
	lblo	cg3_sprite2_lp0


	rts

endfunction















;***********************************************************************************************************************************************************
function	cg3_sprite1	cg3_sprite1_page,cg3_sprite1_tile,cg3_sprite1_x,cg3_sprite1_y,cg3_sprite1_sx,cg3_sprite1_sy
rem	cg3_sprite1( page.b , tile.b , posx.b , posy.b , sizex.b , sizey.b )
rem	alignment at byte level no transparency
rem	
rem	

def	cg3_sprite1_page	byte
def	cg3_sprite1_tile	byte
def	cg3_sprite1_x	byte
def	cg3_sprite1_y	byte
def	cg3_sprite1_sx	byte
def	cg3_sprite1_sy	byte


def	cg3_sprite1_d0	byte
def	cg3_sprite1_d1	byte
def	cg3_sprite1_d2	byte
def	cg3_sprite1_d3	byte

def	cg3_sprite1_cnt	byte
def	cg3_sprite1_sxc	byte
def	cg3_sprite1_syc	byte
def	cg3_sprite1_savex	word

def	cg3_sprite1_trans	byte



stack	x,y,u

cg3_sprite1

; prep x for screen start
	if	b,cg3_sprite1_page=#0
	ldx	#$e00
	else
	ldx	#$1a00
	endif

	lda	#32
	ldb	cg3_sprite1_y
	mul
	leax	d,x

	lda	cg3_sprite1_x
	lsra
	lsra
	leax	a,x
; x is ready to draw
	stx	cg3_sprite1_savex


	ldy	#$2620
	lda	#16
	ldb	cg3_sprite1_tile
	mul
	leay	d,y
; y is ready with tile


	ldb	#0
	stb	cg3_sprite1_sxc
	stb	cg3_sprite1_syc


cg3_sprite1_lp0

	ldb	#8
cg3_sprite1_lp1
	lda	,x
	anda	#192
	sta	cg3_sprite1_d0
	lda	,x
	anda	#48
	sta	cg3_sprite1_d1
	lda	,x
	anda	#12
	sta	cg3_sprite1_d2
	lda	,x
	anda	#3
	sta	cg3_sprite1_d3

	lda	,y
	anda	#192
;	beq	cg3_sprite1_n0
	sta	cg3_sprite1_d0	;write
cg3_sprite1_n0

	lda	,y
	anda	#48
;	beq	cg3_sprite1_n1
	sta	cg3_sprite1_d1	;write
cg3_sprite1_n1

	lda	,y
	anda	#12
;	beq	cg3_sprite1_n2
	sta	cg3_sprite1_d2	;write
cg3_sprite1_n2

	lda	,y
	anda	#3
;	beq	cg3_sprite1_n3
	sta	cg3_sprite1_d3	;write
cg3_sprite1_n3

	lda	cg3_sprite1_d3
	adda	cg3_sprite1_d2
	adda	cg3_sprite1_d1
	adda	cg3_sprite1_d0
	sta	,x




	lda	1,x
	anda	#192
	sta	cg3_sprite1_d0
	lda	1,x
	anda	#48
	sta	cg3_sprite1_d1
	lda	1,x
	anda	#12
	sta	cg3_sprite1_d2
	lda	1,x
	anda	#3
	sta	cg3_sprite1_d3

	lda	1,y
	anda	#192
;	beq	cg3_sprite1_nn0
	sta	cg3_sprite1_d0	;write
cg3_sprite1_nn0

	lda	1,y
	anda	#48
;	beq	cg3_sprite1_nn1
	sta	cg3_sprite1_d1	;write
cg3_sprite1_nn1

	lda	1,y
	anda	#12
;	beq	cg3_sprite1_nn2
	sta	cg3_sprite1_d2	;write
cg3_sprite1_nn2

	lda	1,y
	anda	#3
;	beq	cg3_sprite1_nn3
	sta	cg3_sprite1_d3	;write
cg3_sprite1_nn3

	lda	cg3_sprite1_d3
	adda	cg3_sprite1_d2
	adda	cg3_sprite1_d1
	adda	cg3_sprite1_d0
	sta	1,x


	leax	32,x
	leay	2,y
	decb
	lbne	cg3_sprite1_lp1


	inc	cg3_sprite1_syc
	lda	cg3_sprite1_syc
	cmpa	cg3_sprite1_sy
	lblo	cg3_sprite1_lp0

	clr	cg3_sprite1_syc
	inc	cg3_sprite1_sxc


; prep x for screen start
	ldx	cg3_sprite1_savex
	lda	cg3_sprite1_sxc
	ldb	#2
	mul
	leax	d,x

	lda	cg3_sprite1_sxc
	cmpa	cg3_sprite1_sx
	lblo	cg3_sprite1_lp0


	rts

endfunction






;***********************************************************************************************************************************************************
function	cg3_sprite	cg3_sprite_page,cg3_sprite_bg,cg3_sprite_tile,cg3_sprite_x,cg3_sprite_y,cg3_sprite_sx,cg3_sprite_sy,cg3_sprite_redraw
rem	cg3_sprite( page.b , background.w , tile.b , posx.b , posy.b , sizex.b , sizey.b , redraw.b )
rem	keeps transparency , alignment at pixel level
rem	must have a background layer save defined +3 bytes   so an 8x8 would = 19 bytes
rem	clr the first 3 bytes to perform bg grab reset

def	cg3_sprite_bg	word	;addr to save bg


def	cg3_sprite_page	byte
def	cg3_sprite_pages	word


def	cg3_sprite_test1	byte
def	cg3_sprite_test2	byte
def	cg3_sprite_test3	byte
def	cg3_sprite_redraw	byte	;did sprite tile change

def	cg3_sprite_pset_pp	byte
; try unloading dot first inside pset

def	cg3_sprite_tile	byte
def	cg3_sprite_x	byte
def	cg3_sprite_y	byte
def	cg3_sprite_sx	byte	;size
def	cg3_sprite_sy	byte

def	cg3_sprite_savex	byte
def	cg3_sprite_savey	byte

def	cg3_sprite_cnt	byte
def	cg3_sprite_sxc	byte	;size counters
def	cg3_sprite_syc	byte



def	cg3_sprite_dot	byte
def	cg3_sprite_dec	byte

def	cg3_sprite_store1	word


def	cg3_sprite_pset_x	byte
def	cg3_sprite_pset_y	byte
def	cg3_sprite_pset_col	byte



def	cg3_sprite_pset_dotst	byte
def	cg3_sprite_pset_dotm	byte

stack	x,y,u


cg3_sprite_pset_dotmsk	fcb	63,207,243,252

cg3_sprite_pset_dotmsk2	fcb	192,48,12,3

cg3_sprite_pset_dotcol	fcb	0,85,170,255


cg3_sprite

	lda	cg3_sprite_x
	sta	cg3_sprite_savex
	lda	cg3_sprite_y
	sta	cg3_sprite_savey

; prep x for screen start
	if	b,cg3_sprite_page=#0
	ldd	#$e00
	std	cg3_sprite_pages
	else
	ldd	#$1a00
	std	cg3_sprite_pages
	endif




; lets check bg buff
; if it exists we need to draw that back first but only if sprite moved

	ldx	cg3_sprite_bg
	lda	0,x
	sta	cg3_sprite_test1
	lda	1,x
	sta	cg3_sprite_test2
	lda	2,x
	sta	cg3_sprite_test3




	if	b,cg3_sprite_test1=#0
; ok bad news no bg saved
; change page to bg buff instead
	lda	#1
	sta	0,x
	lda	cg3_sprite_x
	sta	1,x
	lda	cg3_sprite_y
	sta	2,x
	lda	1,x
	sta	cg3_sprite_test2
	lda	2,x
	sta	cg3_sprite_test3
	endif








; check if x,y different
; if so we need to put bg back
	if	b,cg3_sprite_test1=#1
	if	b,cg3_sprite_test2!cg3_sprite_x	or	b,cg3_sprite_test3!cg3_sprite_y	or	b,cg3_sprite_redraw=#1

; dump bg it moved

;counters
	ldb	#0
	stb	cg3_sprite_sxc
	stb	cg3_sprite_syc


; fast bg dump
	ldy	cg3_sprite_bg
	lda	1,y
	sta	cg3_sprite_x
	lda	2,y
	sta	cg3_sprite_y

	


cg3_sprite_bgsave2
	ldu	#$e00
	ldx	cg3_sprite_pages
; x index is at start of screen
	lda	cg3_sprite_y
	ldb	#32
	mul
	leax	d,x	; advance y pos
	leau	d,u
	ldb	cg3_sprite_x
	lsrb
	lsrb
	abx	;ok we are ready to dump bg
	leau	b,u
; line 1

	ldd	0,u
	std	0,x
	lda	2,u
	sta	2,x
	leax	32,x
	leau	32,u
; line 2
	ldd	0,u
	std	0,x
	lda	2,u
	sta	2,x
	leax	32,x
	leau	32,u
; line 3
	ldd	0,u
	std	0,x
	lda	2,u
	sta	2,x
	leax	32,x
	leau	32,u
; line 4
	ldd	0,u
	std	0,x
	lda	2,u
	sta	2,x
	leax	32,x
	leau	32,u
; line 5
	ldd	0,u
	std	0,x
	lda	2,u
	sta	2,x
	leax	32,x
	leau	32,u
; line 6
	ldd	0,u
	std	0,x
	lda	2,u
	sta	2,x
	leax	32,x
	leau	32,u
; line 7
	ldd	0,u
	std	0,x
	lda	2,u
	sta	2,x
	leax	32,x
	leau	32,u
; line 8
	ldd	0,u
	std	0,x
	lda	2,u
	sta	2,x
	leax	32,x
	leau	32,u

; anymore downward?
	lda	cg3_sprite_y
	adda	#8
	sta	cg3_sprite_y	;save for now

	inc	cg3_sprite_syc	;increase counter
	lda	cg3_sprite_syc
	cmpa	cg3_sprite_sy	;size y
	lblo	cg3_sprite_bgsave2

; ok y is done
; reset y and advance x

	clr	cg3_sprite_syc	;reset y counter

; go right any more?
	lda	cg3_sprite_x
	adda	#2
	sta	cg3_sprite_x
	lda	cg3_sprite_savey
	sta	cg3_sprite_y


	inc	cg3_sprite_sxc	;increase counter
	lda	cg3_sprite_sxc
	cmpa	cg3_sprite_sx	;size x
	lblo	cg3_sprite_bgsave2

	lda	cg3_sprite_savex
	sta	cg3_sprite_x	;restored
;saved bg hopefully




;restore
	lda	cg3_sprite_savex
	sta	cg3_sprite_x
	lda	cg3_sprite_savey
	sta	cg3_sprite_y


	clr	cg3_sprite_test1

	endif
	endif











; ok lets code this differently
	if	b,cg3_sprite_test1=#0
;counters
	ldb	#0
	stb	cg3_sprite_sxc
	stb	cg3_sprite_syc
	

	ldy	cg3_sprite_bg
	lda	#1
	sta	0,y
	lda	cg3_sprite_x
	sta	1,y
	lda	cg3_sprite_y
	sta	2,y

; y is ready

; fast bg dump



	ldx	cg3_sprite_bg
	lda	#1
	sta	0,x
	lda	cg3_sprite_savex
	sta	1,x
	lda	cg3_sprite_savey
	sta	2,x	

	clr	cg3_sprite_test1	;need to grab new

;restore
	lda	cg3_sprite_savex
	sta	cg3_sprite_x
	lda	cg3_sprite_savey
	sta	cg3_sprite_y


	endif



























;prep graphic
	ldy	#$2620
	lda	#16
	ldb	cg3_sprite_tile
	mul
	leay	d,y
; y is ready with tile


;counters
	ldb	#0
	stb	cg3_sprite_sxc
	stb	cg3_sprite_syc



cg3_sprite_drawlp2

	ldb	#7
	stb	cg3_sprite_cnt

cg3_sprite_drawlp1

; ok lets look at graphic
; pixel 1
	lda	,y
	anda	#192
	lsra
	lsra
	lsra
	lsra
	lsra
	lsra
	sta	cg3_sprite_pset_col

;first dot draw
	if	b,cg3_sprite_pset_col!#0
	lda	cg3_sprite_x
	sta	cg3_sprite_pset_x
	lda	cg3_sprite_y
	sta	cg3_sprite_pset_y
	if	b,cg3_sprite_pset_x<#128	b,cg3_sprite_pset_y<#96
	pshs	y
	jsr	cg3_sprite_pset
	puls	y
	endif
	endif

; pixel 2
	lda	,y
	anda	#48
	lsra
	lsra
	lsra
	lsra
	sta	cg3_sprite_pset_col

; dot 2 draw
	if	b,cg3_sprite_pset_col!#0
	lda	cg3_sprite_x
	adda	#1
	sta	cg3_sprite_pset_x
	lda	cg3_sprite_y
	sta	cg3_sprite_pset_y
	if	b,cg3_sprite_pset_x<#128	b,cg3_sprite_pset_y<#96
	pshs	y
	jsr	cg3_sprite_pset
	puls	y
	endif
	endif



; pixel 3
	lda	,y
	anda	#12
	lsra
	lsra
	sta	cg3_sprite_pset_col

; dot 3 draw
	if	b,cg3_sprite_pset_col!#0
	lda	cg3_sprite_x
	adda	#2
	sta	cg3_sprite_pset_x
	lda	cg3_sprite_y
	sta	cg3_sprite_pset_y
	if	b,cg3_sprite_pset_x<#128	b,cg3_sprite_pset_y<#96
	pshs	y
	jsr	cg3_sprite_pset
	puls	y
	endif
	endif




; pixel 4
	lda	,y
	anda	#3
	sta	cg3_sprite_pset_col

; dot 4 draw
	if	b,cg3_sprite_pset_col!#0
	lda	cg3_sprite_x
	adda	#3
	sta	cg3_sprite_pset_x
	lda	cg3_sprite_y
	sta	cg3_sprite_pset_y
	if	b,cg3_sprite_pset_x<#128	b,cg3_sprite_pset_y<#96
	pshs	y
	jsr	cg3_sprite_pset
	puls	y
	endif
	endif



	leay	1,y	;advance 1 byte

; pixel 1
	lda	,y
	anda	#192
	lsra
	lsra
	lsra
	lsra
	lsra	
	lsra
	sta	cg3_sprite_pset_col

;first dot draw
	if	b,cg3_sprite_pset_col!#0
	lda	cg3_sprite_x
	adda	#4
	sta	cg3_sprite_pset_x
	lda	cg3_sprite_y
	sta	cg3_sprite_pset_y
	if	b,cg3_sprite_pset_x<#128	b,cg3_sprite_pset_y<#96
	pshs	y
	jsr	cg3_sprite_pset
	puls	y
	endif
	endif




; pixel 2
	lda	,y
	anda	#48
	lsra
	lsra
	lsra
	lsra
	sta	cg3_sprite_pset_col

; dot 2 draw
	if	b,cg3_sprite_pset_col!#0
	lda	cg3_sprite_x
	adda	#5
	sta	cg3_sprite_pset_x
	lda	cg3_sprite_y
	sta	cg3_sprite_pset_y
	if	b,cg3_sprite_pset_x<#128	b,cg3_sprite_pset_y<#96
	pshs	y
	jsr	cg3_sprite_pset
	puls	y
	endif
	endif




; pixel 3
	lda	,y
	anda	#12
	lsra
	lsra
	sta	cg3_sprite_pset_col

; dot 3 draw
	if	b,cg3_sprite_pset_col!#0
	lda	cg3_sprite_x
	adda	#6
	sta	cg3_sprite_pset_x
	lda	cg3_sprite_y
	sta	cg3_sprite_pset_y
	if	b,cg3_sprite_pset_x<#128	b,cg3_sprite_pset_y<#96
	pshs	y
	jsr	cg3_sprite_pset
	puls	y
	endif
	endif






; pixel 4
	lda	,y
	anda	#3
	sta	cg3_sprite_pset_col

; dot 4 draw
	if	b,cg3_sprite_pset_col!#0
	lda	cg3_sprite_x
	adda	#7
	sta	cg3_sprite_pset_x
	lda	cg3_sprite_y
	sta	cg3_sprite_pset_y
	if	b,cg3_sprite_pset_x<#128	b,cg3_sprite_pset_y<#96
	pshs	y
	jsr	cg3_sprite_pset
	puls	y
	endif
	endif





; two bytes done 8 graphic dots drawn




	leay	1,y
	inc	cg3_sprite_y	;advance y down

; check y counter for first 8 lines

	dec	cg3_sprite_cnt
	ldb	cg3_sprite_cnt
	lbne	cg3_sprite_drawlp1


; ok first box drawn
; anymore downward?
	inc	cg3_sprite_syc	;increase counter
	lda	cg3_sprite_syc
	cmpa	cg3_sprite_sy	;size y
	lblo	cg3_sprite_drawlp2

; ok y is done
; reset y and advance x
	lda	cg3_sprite_savey
	sta	cg3_sprite_y
	clr	cg3_sprite_syc	;reset y counter

; go right any more?
	lda	cg3_sprite_x
	adda	#8
	sta	cg3_sprite_x	;advance x

	inc	cg3_sprite_sxc	;increase counter
	lda	cg3_sprite_sxc
	cmpa	cg3_sprite_sx	;size x
	lblo	cg3_sprite_drawlp2
; ok we are done
	rts





; must prime3 color before jump      cg3_sprite_pset_col
; if its 0 then dont bother with pset
;************************************************************************************************************************
cg3_sprite_pset



	ldy	#cg3_sprite_pset_dotmsk2
	ldu	#cg3_sprite_pset_dotcol
	ldx	cg3_sprite_pages
; x index is at start of screen
	lda	cg3_sprite_pset_y
	ldb	#32
	mul
	leax	d,x	; advance y pos
	lda	cg3_sprite_pset_x
	anda	#3	;mask out which dot of 4
	sta	cg3_sprite_pset_dotst
	ldb	cg3_sprite_pset_x
	lsrb
	lsrb
	abx	;ok we are ready to draw (again, result is always 8 bits lcb)
; mask color
	ldb	cg3_sprite_pset_col
	lda	b,u
	ldb	cg3_sprite_pset_dotst
	anda	b,y
	sta	cg3_sprite_pset_dotm	;dot saved
; grab original

	ldu	#cg3_sprite_pset_dotmsk	; 1 byte smaller/1 cycle faster
	lda	,x
	anda	b,u
	adda	cg3_sprite_pset_dotm
	sta	,x




	rts







endfunction





